// pages/opinion/index.js
const app = getApp();
Page({
  /**
   * 页面的初始数据
   */
  data: {
    files: [],
    newAddImg: [],
    textVal: "",
    loading: false,
    subLoad: false,
    success: false,
    troubleList:[
      "投诉", "建议", "故障", "其他"
    ],
    actived:0,
    count:4,
  },
  chooseMedia () {
    var that = this;

    console.log( that.data.count)
    wx.chooseMedia({
      count: that.data.count,
      mediaType: ['image'],
      sizeType: ['original', 'compressed'],
      sourceType: ['album', 'camera'],
      success (res) {
        // tempFilePath可以作为 img 标签的 src 属性显示图片
        wx.showLoading({
          title: '上传中...',
        })
        console.log(res);
        var currData = {};


        const tempFilePaths = res.tempFiles;
        tempFilePaths.forEach((item, index) => {

          wx.uploadFile({
            url: app.globalData.ip + "/imgs/uploadImage",
            method: "post",
            // data:currData,
            // name: "uploadFile",
            filePath: tempFilePaths[index].tempFilePath,
            name: "uploadFile",
            header: app.globalData.headers,
            success: function (res) {
              console.log(that.data.files);
              console.log(JSON.parse(res.data).data);

              that.data.files.push({ url: JSON.parse(res.data).data, id: -999 })
              that.data.newAddImg.push(JSON.parse(res.data).data)
              that.setData({
                files: that.data.files,
                newAddImg: that.data.newAddImg,
                count: 4 - that.data.files.length
              })
              // currData.data = JSON.parse(res.data);


              that.pushImg();
              // console.log(that.data.files);

              // that.updateImgs(currData.type,currData.fkId,currData.data.data);

            },
            fail: function (res) {
              console.log(res);
            },
          });
          wx.hideLoading();
        })
      }
    })
  },
  delImgs (e) {
    var that = this;
    var url = e.currentTarget.dataset.url;
    var id = e.currentTarget.dataset.id;
    console.log(that.data.files)
    wx.showModal({
      title: '提示',
      content: '确定要删除该图片？',
      confirmColor: '#00BEBE',
      success (res) {
        if (res.confirm) {
          that.data.files.forEach((item, index) => {
            if (item.url == url) {
              that.data.files.splice(index, 1);
              that.data.newAddImg.splice(index, 1);
            }
          })
          that.pushImg();
          that.setData({
            files: that.data.files,
            newAddImg: that.data.newAddImg,
            count: 4 - that.data.files.length
          })

        } else if (res.cancel) {
          console.log('用户点击取消')
        }
      }
    })




  },
  pushImg () {
    var that = this;

    console.log(that.data.files);

    that.data.urls = [];
    // that.data.files.forEach(item=>{
    //   that.data.urls.push(item.url)
    // })

    let curr = [];
    that.data.files.forEach(item => {
      curr.push({ url: item.url, id: item.id })
    })
    that.setData({
      urls: curr
    })
  },
  showImgs (e) {
    var that = this;
    console.log(that.data.urls);
    let curr = [];
    that.data.urls.forEach(item => {
      curr.push(item.url)
    })

    wx.previewImage({
      current: e.mark.url, // 当前显示图片的 http 链接
      urls: curr // 需要预览的图片 http 链接列表
    })
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad (options) { },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady () { },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow () { },


  handleUpdatType(e){
    console.log(e)
    this.setData({
      actived:e.target.dataset.index
    })
  },
  handleUpdateImage(){
    wx.chooseMedia({
      count: 1,
      mediaType: ['image'],
      sourceType: ['album', 'camera'],
      maxDuration: 30,
      camera: 'back',
      success(res) {
        console.log('获取上传数据：',res)
          // 调用上传接口
      }
    })
  },



  /**
   * 意见提交事件
   *
   *
   */
  submit () {
    const that = this;
    if (that.data.subLoad) return
    that.data.subLoad = true
console.log(that.data.newAddImg)
// return
// that.setData({
//   success: true,
//   loading: false,
//   subLoad:false
// });

    if (that.data.textVal.trim() != '') {
      console.log(312313123);
      that.setData({
        loading: true,
      });
      wx.request({
        url: app.globalData.ip + "/daotian/feedback/add",
        method: 'post',
        header: app.globalData.headers,
        data: {
          content: that.data.textVal,
          classify: Number(that.data.actived + 1),
          imgs:that.data.newAddImg.toString(),
          appId:app.globalData.appId
        },
        success: function (res) {
          console.log(res);
          if (res.data.status == 200) {
            that.setData({
              success: true,
            });
          } else {
            wx.showToast({
              title: res.data.msg,
              icon: 'none'
            })
          }
          that.setData({
            loading: false,
          });
          that.data.subLoad = false

        },
        fail: function (res) {
          that.setData({
            loading: false,
          });
        },
      });
    } else {
      wx.showToast({
        title: '请输入内容再提交',
        icon: 'none'
      })
    }


  },
  getVal (e) {
    console.log(e);
    this.setData({
      textVal: e.detail.value
    })
    console.log(this.data.textVal);
  },
  goback () {
    // wx.navigateBack({
    //   delta: 1,
    // });
    wx.switchTab({
      url: '../../mine/index',
    })
  },
  goList () {
    wx.navigateTo({
      url: "/pages/opinionList/index",
    });
  },
  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide () { },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload () { },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh () { },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom () { },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage () { },
});
